﻿using System;
using System.Management;

public class CompInf
{
    //-------Имя-компьютера-------
	public static string CompName()
	{
        string s = null;
        ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\CIMV2", "SELECT * FROM Win32_ComputerSystem");
        foreach (ManagementObject queryObj in searcher.Get())
        {s = queryObj["Name"].ToString();}
        return s;
	}

    //------Имя-и-версия-системы------
    public static string SysName()
    {
        string s = null;
        string raz = null;
        if (Environment.Is64BitOperatingSystem) raz = "64-bit";
        else raz = "32-bit";
        ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\CIMV2", "SELECT * FROM Win32_OperatingSystem");
        foreach (ManagementObject queryObj in searcher.Get())
        { s = queryObj["Caption"].ToString() + queryObj["Version"].ToString() + " " + raz; }
        return s;
    }
     
}

public class HardwareInf
{
    //------Общий-объем-установленной-физической-оперативной-памяти-----
    public static long RAM()
    {
        long i = 0;
        ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\CIMV2", "SELECT * FROM Win32_PhysicalMemory");
        foreach (ManagementObject queryObj in searcher.Get())
        { i += Convert.ToInt64(queryObj["Capacity"]);}
        i = i / 1048576;
        return i;
    }

    //-----Модель-и-тактовая-частота-процессора-------
    public static string Processor()
    {
        string s = null;
        ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\CIMV2", "SELECT * FROM Win32_Processor");
        foreach (ManagementObject queryObj in searcher.Get())
        { s = queryObj["Name"].ToString(); }
        return s;
    }

    //----Модели-и-объем-установленных-жестких-дисков-----
    public static string HDD()
    {
        string s = null;
        ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\CIMV2", "SELECT * FROM Win32_DiskDrive WHERE InterfaceType = 'IDE'");
        foreach (ManagementObject queryObj in searcher.Get())
        { s += queryObj["Caption"].ToString() + " " + (Convert.ToInt64(queryObj["Size"]) / 1073741824).ToString() + "Gb" + Environment.NewLine; }
        return s;
    }

    //----Модели-установленных-оптических-приводов----
    public static string OpticalDrive()
    {
        string s = null;
        ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\CIMV2", "SELECT * FROM Win32_CDROMDrive");
        foreach (ManagementObject queryObj in searcher.Get())
        { s += queryObj["Name"].ToString() + Environment.NewLine; }
        return s;
    }

    //-----Видеоконтроллер---
    public static string VideoController()
    {
        string s = null;
        ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\CIMV2", "SELECT * FROM Win32_VideoController");
        foreach (ManagementObject queryObj in searcher.Get())
        { s += queryObj["Name"].ToString() + " " + (Convert.ToInt64(queryObj["AdapterRAM"]) / 1048576).ToString() + "Mb" + Environment.NewLine; }
            return s;
    }

    //-----Mac-Адрес---
    public static string MacAddress(object controller)
    {
        ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\CIMV2", "SELECT * FROM Win32_NetworkAdapterConfiguration WHERE Caption = '" + controller + "'");
        string s = null;
        foreach (ManagementObject queryObj in searcher.Get())
        {
            if (queryObj["MACAddress"] == null)
                s += null;
            else
            s = queryObj["MACAddress"].ToString();
        }
        return s;
    }

    //-----IP-Адрес---
    public static string IPAddress(object controller)
    {
        ManagementObjectSearcher searcher = new ManagementObjectSearcher("root\\CIMV2", "SELECT * FROM Win32_NetworkAdapterConfiguration WHERE Caption = '" + controller + "'");
        string s = null;

        foreach (ManagementObject queryObj in searcher.Get())
        {
            if (queryObj["IPAddress"] == null)
                s += null;
            else
            {
                String[] arrIPAddress = (String[])(queryObj["IPAddress"]);
                foreach (String arrValue in arrIPAddress)
                    s += arrValue;
            }
        }
        return s;
    }

    //------Список Сетевых контроллеров-------
    public static string NetAdapters()
    {
        string s = null;
        ManagementObjectSearcher searcher =
    new ManagementObjectSearcher("root\\CIMV2","SELECT * FROM Win32_NetworkAdapterConfiguration");

        foreach (ManagementObject queryObj in searcher.Get())
         s+=queryObj["Caption"].ToString()+"|";
        return s;
    }
}
